/* ************************************************************************* */
/*                             File -- Boot.cpp                              */
/* ************************************************************************* */

//Date: 21/4/2000

#include "Headers.h"
#include "ITGraph.cpp"
#include "Interface.cpp"
#include "Automata.cpp"
#include "GeneralAuto.cpp"
#include "Transducer.cpp"
#include "Command.cpp"

template<class T, class U>
bool Boot<T,U>::isSameAlpha(std::vector<string> a1,std::vector<string> a2)
{
  std::vector<string>::iterator i = a1.begin();
  ++i;  
  std::vector<string>::iterator j = a2.begin();
  ++j;
  for(;i!=a1.end();++i)
      if(find(j,a2.end(),*i)==a2.end()) return false;
  return true;
}

template<class T, class U>
int Boot<T,U>::filterTrans(std::vector<string>& command)
{
string name1;
string name2;
int unsigned noPara =  command.size();
      if(noPara > 3) { cout << "Too many parameters !"<<endl; return 0;}
      if(noPara==3)
        return 1; 
      if(noPara==2)
	{
         command.resize(3);
         command[2] = "";
         return 1; 
	}  
      if(noPara==1)
	{
         cout<<"Enter source name ?: ";
         cin>>name1;cin.get();
         command.resize(3);
         command[1] = name1;
         command[2] = "";
         return 1; 
	}     	
return 1;
}

template<class T,class U>
int Boot<T,U>::filter3Name(std::vector<string>& command)
{
string name1;
string name2;
string name3;
int unsigned noPara =  command.size();
      if(noPara > 4) { cout << "Too many parameters !"<<endl; return 0;}
      if(noPara==4)
        return 1; 
      if(noPara==3)
	{
         if(command[0]=="producttw")
	   {
              command.resize(4);
              command[3] = command[2];
              command[2] ="";
              return 1; 
	   }
         if(command[0]=="exptoauto")  
	   {
             int unsigned s = command[2].size();
             if(s>1&&command[2][0]!='"'&&command[2][s-1]!='"')
                return 1;
             cout<<"Alphabet ? :";
             cin>>name3;cin.get();
             command.resize(4);
             command[3] = name3;
             return 1; 
	   }

         if(command[0]=="define")  
	   {
             cout<<"Alphabet ? :";
             cin>>name3;cin.get();
             command.resize(4);
             command[3] = name3;
             return 1; 
	   }
         cout<<"Enter destination name ? ";
         cin>>name3;cin.get();
         command.resize(4);
         command[3] = name3;
         return 1; 
	}  
      if(noPara==2)
	{
         if(command[0]=="define"||command[0]=="exptoauto") 
	   {
             cout<<"Enter expression  ?: ";
             cin>>name2;cin.get(); 
             cout<<"Alphabet ?: ";
             cin>>name3;cin.get();
             command.resize(4);
             command[2] = name2;
             command[3] = name3;
             return 1; 
	   } 
         if(command[0]=="producttw")
	   {
             
             cout<<"Enter destination name ?: ";
             cin>>name3;cin.get();
             command.resize(4);  
             command[2] = "";
             command[3] = name3;  
             return 1; 
	   }
         cout<<"Enter name of source2  ?: ";
         cin>>name2;cin.get();
         cout<<"Enter destination name ?: ";
         cin>>name3;cin.get();
         command.resize(4);
         command[2] = name2;
         command[3] = name3;
         return 1; 
	}     	
      if(noPara==1)
	{
         if(command[0]=="define"||command[0]=="exptoauto") 
	   {
             cout<<"Enter variable ?: ";
             cin>>name1;cin.get();
             cout<<"Enter expression  ?: ";
             cin>>name2;cin.get();
             cout<<"Alphabet ? :";
             cin>>name3;cin.get();
             command.resize(4);
             command[1] = name1;
             command[2] = name2;
             command[3] = name3;
             return 1; 
	   }
         if(command[0]=="producttw")
	   {
             cout<<"Enter name of source1 ?: ";
             cin>>name1;cin.get();
             cout<<"Enter destination name ?: ";
             cin>>name3;cin.get();
             command.resize(4);
             command[1] = name1;
             command[2] = "";
             command[3] = name3;  
             return 1; 
	   }

         cout<<"Enter name of source1 ?: ";
         cin>>name1;cin.get();
         cout<<"Enter name of source2 ?: ";
         cin>>name2;cin.get();
	 cout<<"Enter destination name ?: ";
         cin>>name3;cin.get();
         command.resize(4);
         command[1] = name1;
         command[2] = name2;
         command[3] = name3;
         return 1; 
	} 

return 1;
}

template<class T, class U>
int Boot<T,U>::filter2Name(std::vector<string>& command)
{
string name1;
string name2;
int unsigned noPara =  command.size();
      if(noPara > 3) { cout << "Too many parameters !"<<endl; return 0;}
      if(noPara==3)
        return 1; 
      if(noPara==2)
	{
         if(command[0]=="deltrans")
	   { 
             //cin>>name2;cin.get();
             command.resize(3);
             command[2] = "";
             return 1;
	   }
         if(command[0]=="recognize")
	   { 
             command.resize(3);
             command[2] = "";
             return 1;
	   }

         //if(command[0]=="exptoauto")
	 //  { 
         //    command.resize(3);
         //    command[2] = "";
         //    return 1;
	 //  }
 
         cout<<"Enter destination name ?: ";
         cin>>name2;cin.get();
         command.resize(3);
         command[2] = name2;
	}  
      if(noPara==1)
	{
         cout<<"Enter source name ?: ";
         cin>>name1;cin.get();
         if(command[0]=="deltrans")
	   {
             command.resize(3);
             command[1] = name1;
             command[2] = "";
             return 1;
	   }
         if(command[0]=="recognize")
	   { 
             command.resize(3);
             command[1] = name1;
             command[2] = "";
             return 1;
	   }
	 cout<<"Enter destination name ?: ";
         cin>>name2;cin.get();
         command.resize(3);
         command[1] = name1;
         command[2] = name2;
         return 1; 
	}     	
return 1;
}

template<class T, class U>
int Boot<T,U>::filter1Name(std::vector<string>& command)
{
string name,choice;
string name1;
int unsigned noPara =  command.size();
if(noPara > 2) { cout << "Too many parameters !"<<endl; return 0;}
      if(noPara==2) 
        {
          return 1;
	} 
      if(noPara==1)
	{
          if(command[0]=="view") 
            {
             cout<<"Enter file name ?";
             cin>>name1;cin.get();
	    }
	  else if(command[0]=="loadall"||command[0]=="storeall")
	    { name1="";              
	    }
          else 
	    {
              cout<<"Enter name of auto ?";
              cin>>name1;cin.get();
	    }
          command.resize(2);
          command[1] = name1; 
          return 1; 
	}     	
return 1;
}

template<class T, class U>
int Boot<T,U>::filter1Para(std::vector<string>& command, string action)
{
string name,choice;
string name1;
int unsigned noPara =  command.size();
if(noPara > 2) { cout << "Too many parameters !"<<endl; return 0;}
      if(noPara==2) 
        {
          if(command[1]!="a"&&command[1]!="g"&&command[1]!="t")
            { cout << "Machine type is invalid !"<<endl; return 0;}
          return 1;
	} 
      if(noPara==1)
	{
	 do{
	   cout<<"Do you want to "<< action << 
                 " (a)utomata,(g)eneral auto,(t)ransducer ?";
           cin>>choice;cin.get();
         }
         while(choice!="a"&&choice!="g"&&choice!="t");
         command.resize(2);
         command[1] = choice;
         return 1; 
	}     	
return 1;
}


template<class T, class U>
int Boot<T,U>::filter2Paras(std::vector<string>& command, string action)
{
string name,choice;
string name1;
int unsigned noPara =  command.size();
if(noPara > 3) { cout << "Too many parameters !"<<endl; return 0;}
      if(noPara==3) 
        {
          if(command[2]!="a"&&command[2]!="g"&&command[2]!="t")
            { cout << "Machine type is invalid !"<<endl; return 0;}
          //func(command);
          return 1;
	} 
      if(noPara==2)
	{
	 do{
	   cout<<"Do you want to "<< action << 
                 " (a)utomata,(g)eneral auto,(t)ransducer ?";
           cin>>choice;cin.get();
         }
         while(choice!="a"&&choice!="g"&&choice!="t");
         command.resize(3);
         command[2] = choice;
         //func(command); 
         return 1; 
	}     	
      if(noPara==1)
	{
	 do{
	   cout<<"Do you want to "<<action<<
                 " (a)utomata,(g)eneral auto,(t)ransducer ?";
         cin>>choice;cin.get();
         }
         while(choice!="a"&&choice!="g"&&choice!="t");
         cout<<"Enter name ?: ";
         cin>>name;cin.get();
         command.resize(3);
         command[1] = name;
         command[2] = choice;
         //func(command); 
         return 1; 
	}
return 1;
}
template<class T, class U>
int Boot<T,U>::filter2N1P(std::vector<string>& command)
{
string name,choice;
string name1;
string name2;
int unsigned noPara =  command.size();
if(noPara > 4) { cout << "Too many parameters !"<<endl; return 0;}
      if(noPara==4) 
        {
          return 1;
	} 
      if(noPara==3)
	{
         command.resize(4);
         command[3] = "-n"; //"for addstate" 
         return 1; 
	}     	
      if(noPara==2)
	{
	  cout<<"Enter destination name ?: ";
          cin>>name1;cin.get();
          cout<<"Enter type) ?: ";
          cin>>name2;cin.get();
          command.resize(4);
          command[2] = name1;
          if(name2!="-i"&&name2!="-t"&&name2!="+i"&&name2!="+t") name2 = "-n";
          command[3] = name2;
          return 1; 
	}
        if(noPara==1)
	{
         cout<<"Enter name of machine ?: ";
         cin>>name1;cin.get();
         cout<<"Enter destination name ?: ";
         cin>>name2;cin.get();
         cout<<"Enter type ?: ";
         cin>>choice;cin.get();
         command.resize(4);
         command[1] = name1;
         command[2] = name2;
         if(choice!="-i"&&choice!="-t"&&choice!="+i"&&choice!="+t") 
            choice="-n";
         command[3] = choice;
         return 1; 
	}
return 1;
}

template<class T, class U>
void Boot<T,U>::analyser(std::vector<string> command) 
{
   string  word;
   string  dummy;
   string  name;
   string  name1;
   string  dstName;
   string  src1Name;
   string  src2Name;
   string  choice; 

   if(command[0]=="create")  
    { 
      if(filter2Paras(command,"create")==0) return;
      createFunc(command);
      return;    
    }

   if(command[0]=="define")  
    { 
      if(filter3Name(command)==0) return;
      defineFunc(command);
      return;    
    }

   if (command[0]=="kill") 
    { 
      if(filter1Name(command)==0) return;
      killFunc(command);
      return;    	
    }
  
   if (command[0]=="list")
    {
      if(filter1Para(command,"list")==0) return;
      listFunc(command);
      return;
    }  
   if (command[0]=="look")
    {
      if(filter1Name(command)==0) return;
      lookFunc(command);
      return;
    }  

   if (command[0]=="addstate")
    { 
     if(filter2N1P(command)==0) return;
     addstateFunc(command);
     return;  	           
    }

   if (command[0]=="addtrans")
    { 
     if(filterTrans(command)==0) return;
     addtransFunc(command);
     return;    
    }

   if (command[0]=="delstate")
    { 
      if(filter2Name(command)==0) return;
      delstateFuncA(command);
      return;     
    }

   if (command[0]=="language")
    { 
      if(filter2Name(command)==0) return;
      delstateFuncG(command);
      return;     
    }
    if (command[0]=="languageh")
    { 
      if(filter1Name(command)==0) return;
      delstateFuncGH(command);
      return;     
    }

   if (command[0]=="exptoauto")
    { 
      if(filter3Name(command)==0) return;
      expToAutoFunc(command);
      return;            
    }
   if (command[0]=="deltrans")
    { 
      if(filter2Name(command)==0) return;
      deltransFunc(command);
      return;            
    }
   if (command[0]=="delspontrans")
    { 
      if(filter2Name(command)==0) return;
      delspontransFunc(command);
      return;            
    }
   if (command[0]=="renamestate")
    { 
      if(filter3Name(command)==0) return;
      renamestateFunc(command);
      return;     
    }
   if (command[0]=="isdeterm")
    {   
      if(filter1Name(command)==0) return;
      isdetermFunc(command);
      return;
    }
  
   if (command[0]=="iscodeterm")
    {   
      if(filter1Name(command)==0) return;
      iscodetermFunc(command);
      return;
    }
  
   if (command[0]=="isambiguous")
    {   
      if(filter1Name(command)==0) return;
      isambiguousFunc(command);
      return;
    }
  
   if (command[0]=="isemptylang")
    {   
      if(filter1Name(command)==0) return;
      isemptylangFunc(command);
      return;
    }

   if (command[0]=="recognize")
    {
      if(filter2Name(command)==0) return;
      recognizeFunc(command);
      return;	
    }
 
   if (command[0]=="check")
    { 
      if(filter1Name(command)==0) return;
      checkFunc(command);
      return;	
    }
   if (command[0]=="display")  
    { 
      if(filter1Name(command)==0) return;
      displayFunc(command);
      return;        
    }
  
   if (command[0]=="copy")
    {
      if(filter2Name(command)==0) return;
      copyFunc(command);
      return;  	
    }
  
   if (command[0]=="reverse")
    {
      if(filter2Name(command)==0) return;
      reverseFunc(command);
      return; 	
    }
  
  
    if (command[0]=="accauto")
    {
      if(filter1Name(command)==0) return;
      accautoFunc(command);
      return;
    }
  
    if (command[0]=="coaccauto")
    {
      if(filter1Name(command)==0) return;
      coaccautoFunc(command);
      return;
    }
  
    if (command[0]=="trim")
    {
      if(filter1Name(command)==0) return;
      trimFunc(command);
      return; 
    }
    if (command[0]=="complete")
    {
      if(filter1Name(command)==0) return;
      completeFunc(command);
      return; 
    }

    if (command[0]=="determinize")
    {
      if(filter2Name(command)==0) return;
      determinizeFunc(command);
      return; 
    }
  
    if (command[0]=="codeterminize")
    {
      if(filter2Name(command)==0) return;
      codeterminizeFunc(command);
      return; 
    }

    if (command[0]=="minimize")
    {
      if(filter2Name(command)==0) return;
      minimizeFunc(command);
      return; 
    }
    
  
    if (command[0]=="complement")
    {
      if(filter2Name(command)==0) return;
      complementFunc(command);
      return; 
    }
  
    if (command[0]=="union")
    {
      if(filter3Name(command)==0) return;
      unionFunc(command);
      return;    
    }
	
    if (command[0]=="concat")
    {
      if(filter3Name(command)==0) return;
      concatFunc(command);
      return; 
    }

    if (command[0]=="product") 
    {
      if(filter3Name(command)==0) return;
      productFunc(command);
      return;    
    }
    if (command[0]=="producttw") 
    {
      if(filter3Name(command)==0) return;
      producttwFunc(command);
      return;    
    }
    if (command[0]=="productta") 
    {
      if(filter3Name(command)==0) return;
      producttaFunc(command);
      return;    
    }

    if (command[0]=="domain") 
    {
      if(filter2Name(command)==0) return;
      domainFunc(command);
      return;    
    }
    if (command[0]=="image") 
    {
      if(filter2Name(command)==0) return;
      imageFunc(command);
      return;    
    }

    if (command[0]=="compose2t") 
    {
      if(filter3Name(command)==0) return;
      compose2tFunc(command);
      return;    
    }
    if (command[0]=="composeltoexp") 
    {
      if(filter3Name(command)==0) return;
      composeLTOEXPFunc(command);
      return;    
    }
    if (command[0]=="toltoexp") 
    {
      if(filter2Name(command)==0) return;
      toLTOEXPFunc(command);
      return;    
    }
    if (command[0]=="tolutoexp") 
    {
      if(filter2Name(command)==0) return;
      toLUTOEXPFunc(command);
      return;    
    }
    if (command[0]=="reverseinout") 
    {
      if(filter2Name(command)==0) return;
      reverseInOutFunc(command);
      return;    
    }
    if (command[0]=="uniformize") 
    {
      if(filter2Name(command)==0) return;
      uniformizeFunc(command);
      return;    
    }

    if (command[0]=="randauto")
    {
      return;	
    }
	
    if (command[0]=="store")
    {
      if(filter2Name(command)==0) return;
      storeAutoFunc(command);
      return;     	
    }

    if (command[0]=="storeall")
    {
      if(filter1Name(command)==0) return;
      storeAllFunc(command);
      return;     	
    }

    if (command[0]=="load")
    {
      if(filter2Name(command)==0) return;
      loadAutoFunc(command);
      return;   
    }
    
    if (command[0]=="loadall")
    {
      if(filter1Name(command)==0) return;
      loadAllFunc(command);
      return;   
    }

    if (command[0]=="delauto")
    {
      if(filter2Name(command)==0) return;
      deleteAutoFunc(command);
      return;   
    }

    if (command[0]=="view")
    {
      if(filter1Name(command)==0) return;
      viewFunc(command);
      return;   
    }

    if (command[0]=="shell")
    {
       string param="";
       int unsigned i;
       for(i=1;i<command.size();++i)
           param=param+command[i]+" ";
       shell(param);
       return;	
    }
    cout << "bad command !" << endl;	
    return;
} //end of analyser   

template<class T, class U> 
void Boot<T,U>::updateWinId(void)
{ 
  unsigned int i; 
  string tt;
  string tmp1 = "tmp";
  char q = 0;
  tmp1 = tmp1+q; 
  string tmp2 = "xwininfo > " + tmp1;
  cout<<endl;
  cout<<"Please select the window on which you would like"<<endl;
  cout<<"to work by clicking the mouse in that window !"<<endl;
  cout<<endl;
  int xi = system(tmp2.c_str());
  if(xi==-1) { cout<<"Can't update infos of windows !"<<endl;return;}
  std::ifstream	inAuto(tmp1.c_str());
  if(!inAuto) { cout<<"Can't update infos of windows !"<<endl;return;}
  int compte=0;
  while(std::getline(inAuto,tt))  
       {compte++;if(compte>5) break;
       }
  if(compte<=5){ cout<<"Can't update infos of windows !"<<endl;
       inAuto.close(); remove(tmp1.c_str());return;} 
   std::vector<string> vvv =  std::vector<string>(5); 
  readStrings(vvv,tt,true);
  inAuto.close();
  remove(tmp1.c_str());
  setWinId(strtol(vvv[3].c_str(), (char**)NULL,16));
}

template<class T, class U> 
int Boot<T,U>::readStrings(std::vector<string>& v,string& s )
{
  unsigned int i = 0, n =0;
  
  string tmp,tmp1;
  std::getline(cin,tmp);
  
  while(tmp[i]==' '&& i<tmp.size()) i++; 
  if(i==tmp.size()) return n;
  v[n] = "";
  do{
     while(tmp[i]!=' '&& i<tmp.size()) { v[n] = v[n] + tmp[i];++i;}
     tmp1 = v[n];
     s = s + tmp1[0];
     ++n;
     if(i < tmp.size()) 
       {  
         if(n>=v.size()) v.resize(n+1);
         v[n] ="";
         while(tmp[i]==' '&& i<tmp.size()) i++; 
         if(i==tmp.size()) return n;
       }
     else break;
  }while(true);

  return (int)n;
}

template<class T, class U> 
int Boot<T,U>::readStrings(std::vector<string>& v,string tmp, bool f)
{
  unsigned int i = 0, n =0;
  
  string tmp1;
    
  while(tmp[i]==' '&& i<tmp.size()) i++; 
  if(i==tmp.size()) return n;
  v[n] = "";
  do{
     while(tmp[i]!=' '&& i<tmp.size()) { v[n] = v[n] + tmp[i];++i;}
     tmp1 = v[n];
     //s = s + tmp1[0];
     n++; 
     if(n>=v.size()) v.resize(n+1);
     v[n] ="";
     if(i < tmp.size()) 
       {
         while(tmp[i]==' '&& i<tmp.size()) i++; 
         if(i==tmp.size()) return n;
       }
     else break;
  }while(true);

  return (int)n;
}


/* ************************************** */
/* *   The function MAIN                * */
/* ************************************** */

int main() 
{
        //the fisrt component for Automaton
        //the second component for Transducter
        Boot<TreeLabel,TransducerLabel<TreeLabel> > boot  = 
             Boot<TreeLabel,TransducerLabel<TreeLabel> >();

        std::vector<string> commandLine = std::vector<string>(5);
        boot.updateWinId();
        
        string  s;
        int n = 0,i; 	
        string choice;
        std::vector<string> lib = std::vector<string>(2);
        lib[1]="";
        //do{
	//   cout<<"Do you want continue the last section(y/n) ?";	
        //   cin>>choice;cin.get();
        //  }
        //while(choice!="y"&&choice!="Y"&&choice!="n"&&choice!="N");
        //if(choice=="y"||choice=="Y") boot.loadAllFunc(lib);

        while(1) 
        {
	    	boot.prompt();
    		n = boot.readStrings(commandLine,s); 
                std::vector<string> command     = std::vector<string>(n);
                for(i=0;i<n;++i) command[i]=commandLine[i];
               
                if(n==0) continue;         
                
    		if (command[0]=="exit" ||command[0]=="quit" ) 
		  {	   
      		   break;
                  }
    		else if (command[0]=="help") 
      			boot.help();
    		else 
      		        boot.analyser(command);
	}
     
        cout << "See you again !"<<endl;
  	exit (0);
}
  


